/*
 * MX 68HC11 Multitasking Task display routines
 * Uses Interrupt driven output functions
 */
int     *pmxpollq;

struct  TCB   *pTCB;
struct  POLLQ *pPOLL;

char *DayofWeek[] ={"Sunday   ",
                    "Monday   ",
                    "Tuesday  ",
                    "Wednesday",
                    "Thursday ",
                    "Friday   ",
                    "Saturday "}

char *Status[]={  "Running  ",
                  "Sleeping ",
                  "Rcv Mesg ",
                  "Dormant  ",
                  "ISRactive",
                  "ISRdormnt"}

char *TStatus[]={ "Semaphore",
                  "Eventflag"}

/*decode status field into pointer to string*/
char *decstatus(tstat)
int tstat;
{          /* Negative numbers correspond to timer functions */
if (tstat<0) return TStatus[tstat&15];
else         return Status [tstat];
}

showtasks()
{
/* Follow TCB's and display Tasks */
Cprintf("MX Variables start at %4x\n", mxvar());
pTCB=mxvar();
Cprintf(
"Task                TCB   Start Stack Status    Pri SPend SPmin Space\n");
Cprintf(
"----                ---   ----- ----- ------    --- ----- ----- -----\n");

while (pTCB=pTCB->tlink)
   {
   Cprintf("%-18s  %4x  %4x  %4x  %s  %d  %4x  %4x   %d\n",
   pTCB->tname, pTCB, pTCB->tstart, pTCB->tsp, decstatus(pTCB->tstat),
   pTCB->tpriority,pTCB->tspend,pTCB->tspmin,(pTCB->tspmin-pTCB->tspend));
   }
}

showpoll()
{
int   i;
pmxpollq=mxvar(); /* Get start of MX variables */
pmxpollq++;       /* Point to start of POLL queues */

for (i=0;i<5;i++) /* Do each of five POLL queues */
  {
   Cprintf("Poll List %d: ",i);
   if (*pmxpollq)  /* If pointer to poll list not null */
      {
      pPOLL=*pmxpollq;
       /* Do first task */
         Cprintf("%-15s  Message:%4x\n",
                 pPOLL->ptask->tname,  /* Task name */
                 pPOLL->pmesg);        /* Message   */

      /* Remaining tasks on list */
      while (pPOLL=pPOLL->plink)
         Cprintf("             %-15s  Message:%4x\n",
                 pPOLL->ptask->tname,  /* Task name */
                 pPOLL->pmesg);
      pmxpollq++;                      /* Do next poll queue */
      }
   else
      {
      Cputstr("No tasks defined\n");
      pmxpollq++;
      }
  }
}
